package de.hamster.debugger.model;

import java.util.ArrayList; // dibo
import de.hamster.model.*;

/**
 * Dies ist die Oberklasse eines imperativen Hamsterprogramms. Ein imperatives
 * Hamsterprogramm steuert immer den Standardhamster und unterstuetzt dabei die
 * Befehle vor, linksUm, nimm, gib, vornFrei, maulLeer und kornDa. Ausserdem
 * kann ein imperatives Hamsterprogramm jetzt auch ueber die Methoden schreib,
 * liesZahl und liesZeichenkette eine gewisse Ein- und Ausgabe ermoeglichen.
 * 
 * @author $Author: djasper $
 * @version $Revision: 1.2 $
 */
public class IHamster extends Thread {
	/**
	 * Der InstructionProcessor
	 */
	static InstructionProcessor processor;

	/**
	 * Ein imperativer Hamster hat immer die ID -1
	 */
	int id = -1;

	public boolean parallel = false; // dibo 20.04.2005

	// dibo 20.04.2005
	public void start() {
		this.parallel = true;
		super.start();
	}

	// dibo 20.04.2005
	private void _intern_sleep_200405() {
		try {
			if (!this.parallel) {
				return;
			}
			int msec = (int) (Math.random() * 1000 * Thread.NORM_PRIORITY / this
					.getPriority());
			Thread.sleep(0); // dibo to change msec);
		} catch (Exception exc) {
		}
	}

	public void vor() {
		Object o = processor.process(new HamsterInstruction(
				HamsterInstruction.FORWARD, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		if (o instanceof MauerDaException) {
			MauerDaException e = (MauerDaException) o;
			throw new MauerDaException(null, e.getReihe(), e.getSpalte());
		}
	}

	public void linksUm() {
		processor.process(new HamsterInstruction(HamsterInstruction.TURN_LEFT,
				id));
		_intern_sleep_200405(); // dibo 20.04.2005
	}

	public void nimm() {
		Object o = processor.process(new HamsterInstruction(
				HamsterInstruction.PICK_UP, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		if (o instanceof KachelLeerException) {
			KachelLeerException e = (KachelLeerException) o;
			throw new KachelLeerException(null, e.getReihe(), e.getSpalte());
		}
	}

	public void gib() {
		Object o = processor.process(new HamsterInstruction(
				HamsterInstruction.LAY_DOWN, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		if (o instanceof MaulLeerException)
			throw new MaulLeerException(null);
	}

	public boolean vornFrei() {
		Boolean b = (Boolean) processor.process(new HamsterInstruction(
				HamsterInstruction.FREE, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		return b.booleanValue();
	}

	public boolean maulLeer() {
		Boolean b = (Boolean) processor.process(new HamsterInstruction(
				HamsterInstruction.MOUTH_EMPTY, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		return b.booleanValue();
	}

	public boolean kornDa() {
		Boolean b = (Boolean) processor.process(new HamsterInstruction(
				HamsterInstruction.CORN_AVAILABLE, id));
		_intern_sleep_200405(); // dibo 20.04.2005
		return b.booleanValue();
	}

	public void schreib(String text) {
		processor.process(new TerminalInstruction(TerminalInstruction.WRITE,
				id, text));
		_intern_sleep_200405(); // dibo 20.04.2005
	}

	public int liesZahl(String message) {
		Integer i = (Integer) processor.process(new TerminalInstruction(
				TerminalInstruction.READ_INT, id, message));
		_intern_sleep_200405(); // dibo 20.04.2005
		return i.intValue();
	}

	public String liesZeichenkette(String message) {
		String res = (String) processor.process(new TerminalInstruction(
				TerminalInstruction.READ_STRING, id, message));
		_intern_sleep_200405(); // dibo 20.04.2005
		return res;
	}
	
}
