/**
 * Repraesentation eines Spielers beim Kalah-Spiel
 * 
 * @author Dietrich Boles (Universitaet Oldenburg)
 * @version 1.0 (29.01.2006)
 * 
 */
public interface Spieler {

	/**
	 * kennzeichnet einen Spieler als Spieler A oder B
	 * 
	 * @param istSpielerA
	 *            true, falls es sich um Spieler A handeln soll; false, falls es
	 *            sich um Spieler B handeln soll
	 */
	public void setzeSpieler(boolean istSpielerA);

	/**
	 * Ueberpruefung, welcher Spieler es ist
	 * 
	 * @return true, falls es sich um Spieler A handelt; false sonst
	 */
	public boolean istSpielerA();

	/**
	 * liefert A oder B, je nachdem, welcher Spielertyp es ist
	 * 
	 * @return "A", falls es sich um Spieler A handelt, "B" sonst
	 */
	public String liefereSpielerTyp();

	/**
	 * uebergibt dem Spieler die Spielregeln
	 * 
	 * @param regeln
	 *            die gueltigen Spielregeln
	 */
	public void teileSpielregelnMit(Spielregeln regeln);

	/**
	 * in Ausgangsposition begeben
	 */
	public void begibDichAufAusgangsKachel();

	/**
	 * ermittelt den naechsten Spielzug, fuehrt ihn aus und liefert ihn
	 * 
	 * @return der naechste Spielzug des Spielers
	 */
	public Spielzug naechsterSpielzug();

	/**
	 * sammelt uebrig gebliebene Koerner ein und packt sie ins eigene Kalah
	 */
	public void sammleResteUndBringSieZumKalah();

	/**
	 * beliebige Aktion, die ein Spieler nach Ende des Spiels durchfuehrt;
	 * uebergeben wird die Information, ob der Spieler gewonnen hat
	 * 
	 * @param istSieger
	 *            true, falls der Spieler gewonnen hat; sonst false
	 */
	public void spielBeenden(boolean istSieger);
}
